Index: /branches/UKMO/AMM15_v3_6_STABLE_package_collate_spectral_optics/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90
===================================================================
--- /branches/UKMO/AMM15_v3_6_STABLE_package_collate_spectral_optics/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 12447)
+++ /branches/UKMO/AMM15_v3_6_STABLE_package_collate_spectral_optics/NEMOGCM/NEMO/OPA_SRC/SBC/sbccpl.F90	(revision 12448)
@@ -996,4 +1205,111 @@
       IF( srcv(jpr_co2)%laction )   atm_co2(:,:) = frcv(jpr_co2)%z3(:,:,1)
 #endif
+      !   
+      !                                                      ! ========================= !   
+      !                                                      ! Mean Sea Level Pressure   !   (taum)   
+      !                                                      ! ========================= !   
+      !   
+      IF( srcv(jpr_mslp)%laction ) THEN                    ! UKMO SHELF effect of atmospheric pressure on SSH   
+          IF( ln_apr_dyn ) THEN
+             IF( kt /= nit000 )   ssh_ibb(:,:) = ssh_ib(:,:)    !* Swap of ssh_ib fields   
+           
+             !                                                  !* update the reference atmospheric pressure (if necessary) 
+             IF( ln_ref_apr )  rn_pref = glob_sum( frcv(jpr_mslp)%z3(:,:,1) * e1e2t(:,:) ) / tarea 
+           
+             ssh_ib(:,:) = - ( frcv(jpr_mslp)%z3(:,:,1) - rn_pref ) * r1_grau    ! equivalent ssh (inverse barometer)   
+             apr   (:,:) =     frcv(jpr_mslp)%z3(:,:,1) !atmospheric pressure   
+             ! 
+             CALL iom_put( "ssh_ib", ssh_ib )                                    !* output the inverse barometer ssh
+           
+             !                                         ! ---------------------------------------- ! 
+             IF( kt == nit000 ) THEN                   !   set the forcing field at nit000 - 1    ! 
+                !                                      ! ---------------------------------------- ! 
+                !* Restart: read in restart file 
+                IF( ln_rstart .AND. iom_varid( numror, 'ssh_ibb', ldstop = .FALSE. ) > 0 ) THEN 
+                   IF(lwp) WRITE(numout,*) 'sbc_cpl:   ssh_ibb read in the restart file' 
+                   CALL iom_get( numror, jpdom_autoglo, 'ssh_ibb', ssh_ibb )   ! before inv. barometer ssh 
+                ELSE                                         !* no restart: set from nit000 values 
+                   IF(lwp) WRITE(numout,*) 'sbc_cpl:   ssh_ibb set to nit000 values' 
+                   ssh_ibb(:,:) = ssh_ib(:,:) 
+                ENDIF 
+             ENDIF 
+             !                                         ! ---------------------------------------- ! 
+             IF( lrst_oce ) THEN                       !      Write in the ocean restart file     ! 
+                !                                      ! ---------------------------------------- ! 
+                IF(lwp) WRITE(numout,*) 
+                IF(lwp) WRITE(numout,*) 'sbc_cpl : ssh_ib written in ocean restart file at it= ', kt,' date= ', ndastp 
+                IF(lwp) WRITE(numout,*) '~~~~' 
+                CALL iom_rstput( kt, nitrst, numrow, 'ssh_ibb' , ssh_ib ) 
+             ENDIF 
+          ENDIF 
+        
+          ! Update mean ssh 
+          CALL sbc_ssm_cpl( kt )
+      END IF   
+      !  
+      IF( ln_sdw ) THEN  ! Stokes Drift correction activated  
+      !                                                      ! ========================= !   
+      !                                                      !       Stokes drift u,v    !  
+      !                                                      ! ========================= !   
+      IF( srcv(jpr_sdrftx)%laction .AND. srcv(jpr_sdrfty)%laction ) THEN 
+                                     ut0sd(:,:) = frcv(jpr_sdrftx)%z3(:,:,1)  
+                                     vt0sd(:,:) = frcv(jpr_sdrfty)%z3(:,:,1)  
+      ENDIF
+      !  
+      !                                                      ! ========================= !   
+      !                                                      !      Wave mean period     !  
+      !                                                      ! ========================= !   
+         IF( srcv(jpr_wper)%laction ) wmp(:,:) = frcv(jpr_wper)%z3(:,:,1)  
+      !  
+      !                                                      ! ========================= !   
+      !                                                      !  Significant wave height  !  
+      !                                                      ! ========================= !   
+         IF( srcv(jpr_hsig)%laction ) hsw(:,:) = frcv(jpr_hsig)%z3(:,:,1)  
+      !  
+      !                                                      ! ========================= !   
+      !                                                      !    Wave peak frequency    !  
+      !                                                      ! ========================= !   
+         IF( srcv(jpr_wfreq)%laction ) wfreq(:,:) = frcv(jpr_wfreq)%z3(:,:,1)  
+      ! 
+      !                                                      ! ========================= !
+      !                                                      !    Vertical mixing Qiao   !  
+      !                                                      ! ========================= !   
+         IF( srcv(jpr_wnum)%laction .AND. ln_zdfqiao ) wnum(:,:) = frcv(jpr_wnum)%z3(:,:,1)  
+       
+         ! Calculate the 3D Stokes drift both in coupled and not fully uncoupled mode  
+         IF( (srcv(jpr_sdrftx)%laction .AND. srcv(jpr_sdrfty)%laction) .OR. srcv(jpr_wper)%laction &  
+                                        .OR. srcv(jpr_hsig)%laction   .OR. srcv(jpr_wfreq)%laction) &
+            CALL sbc_stokes()  
+      ENDIF  
+      !                                                      ! ========================= !   
+      !                                                      ! Stress adsorbed by waves  !  
+      !                                                      ! ========================= !   
+      IF( srcv(jpr_tauoc)%laction .AND. ln_tauoc ) THEN 
+         tauoc_wave(:,:) = frcv(jpr_tauoc)%z3(:,:,1) 
+         ! cap the value of tauoc 
+         WHERE(tauoc_wave <   0.0 ) tauoc_wave = 1.0 
+         WHERE(tauoc_wave > 100.0 ) tauoc_wave = 1.0 
+      ENDIF 
+      !                                                      ! ========================= !   
+      !                                                      ! Stress component by waves !  
+      !                                                      ! ========================= !   
+      IF( srcv(jpr_tauwx)%laction .AND. srcv(jpr_tauwy)%laction .AND. ln_tauw ) THEN 
+         tauw_x(:,:) = frcv(jpr_tauwx)%z3(:,:,1) 
+         tauw_y(:,:) = frcv(jpr_tauwy)%z3(:,:,1) 
+         ! cap the value of tauoc 
+         WHERE(tauw_x < -100.0 ) tauw_x = 0.0 
+         WHERE(tauw_x >  100.0 ) tauw_x = 0.0 
+         WHERE(tauw_y < -100.0 ) tauw_y = 0.0 
+         WHERE(tauw_y >  100.0 ) tauw_y = 0.0 
+      ENDIF
+       
+      !                                                      ! ========================= !   
+      !                                                      !   Wave to ocean energy    !
+      !                                                      ! ========================= !   
+      IF( srcv(jpr_phioc)%laction .AND. ln_phioc ) THEN 
+         rn_crban(:,:) = 29.0 * frcv(jpr_phioc)%z3(:,:,1) 
+         WHERE( rn_crban <    0.0 ) rn_crban = 0.0 
+         WHERE( rn_crban > 1000.0 ) rn_crban = 1000.0 
+      ENDIF 
 
       !  Fields received by SAS when OASIS coupling
@@ -1067,5 +1383,5 @@
                CALL ctl_stop( 'sbc_cpl_rcv: wrong definition of sn_rcv_emp%cldes' )
             END SELECT
-         ELSE
+         ELSE IF( ll_purecpl ) THEN
             zemp(:,:) = 0._wp
          ENDIF
@@ -1075,6 +1391,7 @@
          IF( srcv(jpr_cal)%laction )     zemp(:,:) = zemp(:,:) - frcv(jpr_cal)%z3(:,:,1)
          
-         IF( ln_mixcpl ) THEN   ;   emp(:,:) = emp(:,:) * xcplmask(:,:,0) + zemp(:,:) * zmsk(:,:)
-         ELSE                   ;   emp(:,:) =                              zemp(:,:)
+         IF( ln_mixcpl .AND. ( srcv(jpr_oemp)%laction .OR. srcv(jpr_rain)%laction )) THEN 
+                                         emp(:,:) = emp(:,:) * xcplmask(:,:,0) + zemp(:,:) * zmsk(:,:) 
+         ELSE IF( ll_purecpl ) THEN  ;   emp(:,:) = zemp(:,:)
          ENDIF
          !
@@ -1091,6 +1408,7 @@
             ENDIF
          ENDIF
-         IF( ln_mixcpl ) THEN   ;   qns(:,:) = qns(:,:) * xcplmask(:,:,0) + zqns(:,:) * zmsk(:,:)
-         ELSE                   ;   qns(:,:) =                              zqns(:,:)
+         IF( ln_mixcpl .AND. ( srcv(jpr_qnsoce)%laction .OR. srcv(jpr_qnsmix)%laction )) THEN 
+                                          qns(:,:) = qns(:,:) * xcplmask(:,:,0) + zqns(:,:) * zmsk(:,:) 
+         ELSE IF( ll_purecpl ) THEN   ;   qns(:,:) = zqns(:,:)
          ENDIF
 
@@ -1101,6 +1419,7 @@
          ENDIF
          IF( ln_dm2dc .AND. ln_cpl )   zqsr(:,:) = sbc_dcy( zqsr )   ! modify qsr to include the diurnal cycle
-         IF( ln_mixcpl ) THEN   ;   qsr(:,:) = qsr(:,:) * xcplmask(:,:,0) + zqsr(:,:) * zmsk(:,:)
-         ELSE                   ;   qsr(:,:) =                              zqsr(:,:)
+         IF( ln_mixcpl .AND. ( srcv(jpr_qsroce)%laction .OR. srcv(jpr_qsrmix)%laction )) THEN 
+                                          qsr(:,:) = qsr(:,:) * xcplmask(:,:,0) + zqsr(:,:) * zmsk(:,:) 
+         ELSE IF( ll_purecpl ) THEN   ;   qsr(:,:) = zqsr(:,:)
          ENDIF
          !
@@ -1113,5 +1432,5 @@
       ENDIF
       !
-      CALL wrk_dealloc( jpi,jpj, ztx, zty, zmsk, zemp, zqns, zqsr )
+      CALL wrk_dealloc( jpi,jpj, ztx, zty, ztx2, zty2, zmsk, zemp, zqns, zqsr )
       !
       IF( nn_timing == 1 )  CALL timing_stop('sbc_cpl_rcv')
@@ -1708,4 +2027,5 @@
       !
       INTEGER ::   ji, jj, jl   ! dummy loop indices
+      INTEGER ::   ikchoix
       INTEGER ::   isec, info   ! local integer
       REAL(wp) ::   zumax, zvmax
@@ -1736,5 +2056,5 @@
             !
             SELECT CASE( sn_snd_temp%cldes)
-            CASE( 'oce only'             )   ;   ztmp1(:,:) =   ztmp1(:,:) + rt0
+            CASE( 'oce only'             )   ;   ztmp1(:,:) = (ztmp1(:,:) + rt0) * tmask(:,:,1)
             CASE( 'oce and ice'          )   ;   ztmp1(:,:) =   ztmp1(:,:) + rt0
                SELECT CASE( sn_snd_temp%clcat )
@@ -1765,4 +2085,5 @@
                   ztmp1(:,:) = ztmp1(:,:) + tn_ice(:,:,jl) * a_i(:,:,jl)
                ENDDO
+            CASE( 'none'         )       ! nothing to do
             CASE default                     ;   CALL ctl_stop( 'sbc_cpl_snd: wrong definition of sn_snd_temp%cldes' )
             END SELECT
@@ -1889,5 +2210,5 @@
          !                                                  j+1   j     -----V---F
          ! surface velocity always sent from T point                     !       |
-         !                                                        j      |   T   U
+         ! [except for HadGEM3]                                   j      |   T   U
          !                                                               |       |
          !                                                   j    j-1   -I-------|
@@ -1901,10 +2222,20 @@
             SELECT CASE( TRIM( sn_snd_crt%cldes ) )
             CASE( 'oce only'             )      ! C-grid ==> T
-               DO jj = 2, jpjm1
-                  DO ji = fs_2, fs_jpim1   ! vector opt.
-                     zotx1(ji,jj) = 0.5 * ( un(ji,jj,1) + un(ji-1,jj  ,1) )
-                     zoty1(ji,jj) = 0.5 * ( vn(ji,jj,1) + vn(ji  ,jj-1,1) ) 
-                  END DO
-               END DO
+               IF ( TRIM( sn_snd_crt%clvgrd ) == 'T' ) THEN   
+                  DO jj = 2, jpjm1   
+                     DO ji = fs_2, fs_jpim1   ! vector opt.   
+                        zotx1(ji,jj) = 0.5 * ( un(ji,jj,1) + un(ji-1,jj  ,1) )   
+                        zoty1(ji,jj) = 0.5 * ( vn(ji,jj,1) + vn(ji,jj-1,1) )    
+                     END DO   
+                  END DO   
+               ELSE   
+                  ! Temporarily Changed for UKV   
+                  DO jj = 2, jpjm1   
+                     DO ji = 2, jpim1   
+                        zotx1(ji,jj) = un(ji,jj,1)   
+                        zoty1(ji,jj) = vn(ji,jj,1)   
+                     END DO   
+                  END DO   
+               ENDIF 
             CASE( 'weighted oce and ice' )   
                SELECT CASE ( cp_ice_msh )
@@ -1930,14 +2261,28 @@
                   END DO
                CASE( 'F' )                      ! Ocean on C grid, Ice on F-point (B-grid) ==> T
-                  DO jj = 2, jpjm1
-                     DO ji = 2, jpim1   ! NO vector opt.
-                        zotx1(ji,jj) = 0.5  * ( un(ji,jj,1)      + un(ji-1,jj  ,1) ) * zfr_l(ji,jj)  
-                        zoty1(ji,jj) = 0.5  * ( vn(ji,jj,1)      + vn(ji  ,jj-1,1) ) * zfr_l(ji,jj)  
-                        zitx1(ji,jj) = 0.25 * ( u_ice(ji-1,jj-1) + u_ice(ji,jj-1)                     &
-                           &                  + u_ice(ji-1,jj  ) + u_ice(ji,jj  )  ) *  fr_i(ji,jj)
-                        zity1(ji,jj) = 0.25 * ( v_ice(ji-1,jj-1) + v_ice(ji,jj-1)                     &
-                           &                  + v_ice(ji-1,jj  ) + v_ice(ji,jj  )  ) *  fr_i(ji,jj)
-                     END DO
-                  END DO
+                  IF ( TRIM( sn_snd_crt%clvgrd ) == 'T' ) THEN   
+                     DO jj = 2, jpjm1   
+                        DO ji = 2, jpim1   ! NO vector opt.   
+                           zotx1(ji,jj) = 0.5  * ( un(ji,jj,1) + un(ji-1,jj,1) ) * zfr_l(ji,jj)   &      
+                                  &       + 0.25 * ( u_ice(ji-1,jj-1) + u_ice(ji,jj-1)                     &   
+                                  &                + u_ice(ji-1,jj  ) + u_ice(ji,jj  )  ) *  fr_i(ji,jj)   
+                           zoty1(ji,jj) = 0.5  * ( vn(ji,jj,1) + vn(ji,jj-1,1) ) * zfr_l(ji,jj)   &   
+                                  &       + 0.25 * ( v_ice(ji-1,jj-1) + v_ice(ji,jj-1)                     &   
+                                  &                + v_ice(ji-1,jj  ) + v_ice(ji,jj  )  ) *  fr_i(ji,jj)   
+                        END DO   
+                     END DO   
+#if defined key_cice   
+                  ELSE   
+                     ! Temporarily Changed for HadGEM3   
+                     DO jj = 2, jpjm1   
+                        DO ji = 2, jpim1   ! NO vector opt.   
+                           zotx1(ji,jj) = (1.0-fr_iu(ji,jj)) * un(ji,jj,1)             &   
+                                &              + fr_iu(ji,jj) * 0.5 * ( u_ice(ji,jj-1) + u_ice(ji,jj) )    
+                           zoty1(ji,jj) = (1.0-fr_iv(ji,jj)) * vn(ji,jj,1)             &   
+                                &              + fr_iv(ji,jj) * 0.5 * ( v_ice(ji-1,jj) + v_ice(ji,jj) )    
+                        END DO   
+                     END DO   
+#endif   
+                  ENDIF 
                END SELECT
                CALL lbc_lnk( zitx1, 'T', -1. )   ;   CALL lbc_lnk( zity1, 'T', -1. )
@@ -1984,14 +2329,38 @@
          IF( TRIM( sn_snd_crt%clvor ) == 'eastward-northward' ) THEN             ! Rotation of the components
             !                                                                     ! Ocean component
-            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocx1)%clgrid, 'ij->e', ztmp1 )       ! 1st component 
-            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocx1)%clgrid, 'ij->n', ztmp2 )       ! 2nd component 
-            zotx1(:,:) = ztmp1(:,:)                                                   ! overwrite the components 
-            zoty1(:,:) = ztmp2(:,:)
-            IF( ssnd(jps_ivx1)%laction ) THEN                                     ! Ice component
-               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->e', ztmp1 )    ! 1st component 
-               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->n', ztmp2 )    ! 2nd component 
-               zitx1(:,:) = ztmp1(:,:)                                                ! overwrite the components 
-               zity1(:,:) = ztmp2(:,:)
-            ENDIF
+             IF ( TRIM( sn_snd_crt%clvgrd ) == 'T' ) THEN   
+                CALL rot_rep( zotx1, zoty1, ssnd(jps_ocx1)%clgrid, 'ij->e', ztmp1 )       ! 1st component   
+                CALL rot_rep( zotx1, zoty1, ssnd(jps_ocx1)%clgrid, 'ij->n', ztmp2 )       ! 2nd component   
+                zotx1(:,:) = ztmp1(:,:)                                                   ! overwrite the components   
+                zoty1(:,:) = ztmp2(:,:)   
+                IF( ssnd(jps_ivx1)%laction ) THEN                  ! Ice component   
+                   CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->e', ztmp1 )    ! 1st component   
+                   CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->n', ztmp2 )    ! 2nd component   
+                   zitx1(:,:) = ztmp1(:,:) ! overwrite the components   
+                   zity1(:,:) = ztmp2(:,:)   
+                ENDIF   
+             ELSE   
+                ! Temporary code for HadGEM3 - will be removed eventually.   
+                ! Only applies when we want uvel on U grid and vvel on V grid   
+                ! Rotate U and V onto geographic grid before sending.   
+             
+                DO jj=2,jpjm1   
+                   DO ji=2,jpim1   
+                      ztmp1(ji,jj)=0.25*vmask(ji,jj,1)      &   
+                           *(zotx1(ji,jj)+zotx1(ji-1,jj)    &   
+                           +zotx1(ji,jj+1)+zotx1(ji-1,jj+1))   
+                      ztmp2(ji,jj)=0.25*umask(ji,jj,1)      &   
+                           *(zoty1(ji,jj)+zoty1(ji+1,jj)    &   
+                           +zoty1(ji,jj-1)+zoty1(ji+1,jj-1))   
+                   ENDDO   
+                ENDDO   
+                   
+                ! Ensure any N fold and wrap columns are updated   
+                CALL lbc_lnk(ztmp1, 'V', -1.0)   
+                CALL lbc_lnk(ztmp2, 'U', -1.0)   
+                   
+                ikchoix = -1   
+                CALL repcmo(zotx1,ztmp2,ztmp1,zoty1,zotx1,zoty1,ikchoix)   
+            ENDIF   
          ENDIF
          !
@@ -2019,4 +2388,148 @@
       ENDIF
       !
+      !                                                      ! ------------------------- !   
+      !                                                      !  Surface current to waves !   
+      !                                                      ! ------------------------- !   
+      IF( ssnd(jps_ocxw)%laction .OR. ssnd(jps_ocyw)%laction ) THEN   
+          !       
+          !                                                  j+1  j     -----V---F   
+          ! surface velocity always sent from T point                    !       |   
+          !                                                       j      |   T   U   
+          !                                                              |       |   
+          !                                                   j   j-1   -I-------|   
+          !                                               (for I)        |       |   
+          !                                                             i-1  i   i   
+          !                                                              i      i+1 (for I)   
+          SELECT CASE( TRIM( sn_snd_crtw%cldes ) )   
+          CASE( 'oce only'             )      ! C-grid ==> T   
+             DO jj = 2, jpjm1   
+                DO ji = fs_2, fs_jpim1   ! vector opt.   
+                   zotx1(ji,jj) = 0.5 * ( un(ji,jj,1) + un(ji-1,jj  ,1) )   
+                   zoty1(ji,jj) = 0.5 * ( vn(ji,jj,1) + vn(ji , jj-1,1) )    
+                END DO   
+             END DO   
+          CASE( 'weighted oce and ice' )      
+             SELECT CASE ( cp_ice_msh )   
+             CASE( 'C' )                      ! Ocean and Ice on C-grid ==> T   
+                DO jj = 2, jpjm1   
+                   DO ji = fs_2, fs_jpim1   ! vector opt.   
+                      zotx1(ji,jj) = 0.5 * ( un   (ji,jj,1) + un (ji-1,jj  ,1) ) * zfr_l(ji,jj)     
+                      zoty1(ji,jj) = 0.5 * ( vn   (ji,jj,1) + vn (ji  ,jj-1,1) ) * zfr_l(ji,jj)   
+                      zitx1(ji,jj) = 0.5 * ( u_ice(ji,jj  ) + u_ice(ji-1,jj    ) ) *  fr_i(ji,jj)   
+                      zity1(ji,jj) = 0.5 * ( v_ice(ji,jj  ) + v_ice(ji  ,jj-1  ) ) *  fr_i(ji,jj)   
+                   END DO   
+                END DO   
+             CASE( 'I' )                      ! Ocean on C grid, Ice on I-point (B-grid) ==> T   
+                DO jj = 2, jpjm1   
+                   DO ji = 2, jpim1   ! NO vector opt.   
+                      zotx1(ji,jj) = 0.5  * ( un(ji,jj,1)      + un(ji-1,jj  ,1) ) * zfr_l(ji,jj)     
+                      zoty1(ji,jj) = 0.5  * ( vn(ji,jj,1)      + vn(ji  ,jj-1,1) ) * zfr_l(ji,jj)     
+                      zitx1(ji,jj) = 0.25 * ( u_ice(ji+1,jj+1) + u_ice(ji,jj+1)                     &   
+                         &                  + u_ice(ji+1,jj  ) + u_ice(ji,jj  )  ) *  fr_i(ji,jj)   
+                      zity1(ji,jj) = 0.25 * ( v_ice(ji+1,jj+1) + v_ice(ji,jj+1)                     &   
+                         &                  + v_ice(ji+1,jj  ) + v_ice(ji,jj  )  ) *  fr_i(ji,jj)   
+                   END DO   
+                END DO   
+             CASE( 'F' )                      ! Ocean on C grid, Ice on F-point (B-grid) ==> T   
+                DO jj = 2, jpjm1   
+                   DO ji = 2, jpim1   ! NO vector opt.   
+                      zotx1(ji,jj) = 0.5  * ( un(ji,jj,1)      + un(ji-1,jj  ,1) ) * zfr_l(ji,jj)     
+                      zoty1(ji,jj) = 0.5  * ( vn(ji,jj,1)      + vn(ji  ,jj-1,1) ) * zfr_l(ji,jj)     
+                      zitx1(ji,jj) = 0.25 * ( u_ice(ji-1,jj-1) + u_ice(ji,jj-1)                     &   
+                         &                  + u_ice(ji-1,jj  ) + u_ice(ji,jj  )  ) *  fr_i(ji,jj)   
+                      zity1(ji,jj) = 0.25 * ( v_ice(ji-1,jj-1) + v_ice(ji,jj-1)                     &   
+                         &                  + v_ice(ji-1,jj  ) + v_ice(ji,jj  )  ) *  fr_i(ji,jj)   
+                   END DO   
+                END DO   
+             END SELECT   
+             CALL lbc_lnk( zitx1, 'T', -1. )   ;   CALL lbc_lnk( zity1, 'T', -1. )   
+          CASE( 'mixed oce-ice'        )   
+             SELECT CASE ( cp_ice_msh )   
+             CASE( 'C' )                      ! Ocean and Ice on C-grid ==> T   
+                DO jj = 2, jpjm1   
+                   DO ji = fs_2, fs_jpim1   ! vector opt.   
+                      zotx1(ji,jj) = 0.5 * ( un   (ji,jj,1) + un(ji-1,jj  ,1) ) * zfr_l(ji,jj)   &   
+                         &         + 0.5 * ( u_ice(ji,jj  ) + u_ice(ji-1,jj    ) ) *  fr_i(ji,jj)   
+                      zoty1(ji,jj) = 0.5 * ( vn   (ji,jj,1) + vn(ji  ,jj-1,1) ) * zfr_l(ji,jj)   &   
+                         &         + 0.5 * ( v_ice(ji,jj  ) + v_ice(ji  ,jj-1  ) ) *  fr_i(ji,jj)   
+                   END DO   
+                END DO   
+             CASE( 'I' )                      ! Ocean on C grid, Ice on I-point (B-grid) ==> T   
+                DO jj = 2, jpjm1   
+                   DO ji = 2, jpim1   ! NO vector opt.   
+                      zotx1(ji,jj) = 0.5  * ( un(ji,jj,1)      + un(ji-1,jj  ,1) ) * zfr_l(ji,jj)   &      
+                         &         + 0.25 * ( u_ice(ji+1,jj+1) + u_ice(ji,jj+1)                     &   
+                         &                  + u_ice(ji+1,jj  ) + u_ice(ji,jj  )  ) *  fr_i(ji,jj)   
+                      zoty1(ji,jj) = 0.5  * ( vn(ji,jj,1)      + vn(ji  ,jj-1,1) ) * zfr_l(ji,jj)   &    
+                         &         + 0.25 * ( v_ice(ji+1,jj+1) + v_ice(ji,jj+1)                     &   
+                         &                  + v_ice(ji+1,jj  ) + v_ice(ji,jj  )  ) *  fr_i(ji,jj)   
+                   END DO   
+                END DO   
+             CASE( 'F' )                      ! Ocean on C grid, Ice on F-point (B-grid) ==> T   
+                DO jj = 2, jpjm1   
+                   DO ji = 2, jpim1   ! NO vector opt.   
+                      zotx1(ji,jj) = 0.5  * ( un(ji,jj,1)      + un(ji-1,jj  ,1) ) * zfr_l(ji,jj)   &      
+                         &         + 0.25 * ( u_ice(ji-1,jj-1) + u_ice(ji,jj-1)                     &   
+                         &                  + u_ice(ji-1,jj  ) + u_ice(ji,jj  )  ) *  fr_i(ji,jj)   
+                      zoty1(ji,jj) = 0.5  * ( vn(ji,jj,1)      + vn(ji  ,jj-1,1) ) * zfr_l(ji,jj)   &    
+                         &         + 0.25 * ( v_ice(ji-1,jj-1) + v_ice(ji,jj-1)                     &   
+                         &                  + v_ice(ji-1,jj  ) + v_ice(ji,jj  )  ) *  fr_i(ji,jj)   
+                   END DO   
+                END DO   
+             END SELECT   
+          END SELECT   
+         CALL lbc_lnk( zotx1, ssnd(jps_ocxw)%clgrid, -1. )   ; CALL lbc_lnk( zoty1, ssnd(jps_ocyw)%clgrid, -1. )   
+         !   
+         !   
+         IF( TRIM( sn_snd_crtw%clvor ) == 'eastward-northward' ) THEN             ! Rotation of the components   
+         !                                                                        ! Ocean component   
+            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocxw)%clgrid, 'ij->e', ztmp1 )       ! 1st component    
+            CALL rot_rep( zotx1, zoty1, ssnd(jps_ocxw)%clgrid, 'ij->n', ztmp2 )       ! 2nd component    
+            zotx1(:,:) = ztmp1(:,:)                                                   ! overwrite the components    
+            zoty1(:,:) = ztmp2(:,:)    
+            IF( ssnd(jps_ivx1)%laction ) THEN                                     ! Ice component   
+               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->e', ztmp1 )    ! 1st component    
+               CALL rot_rep( zitx1, zity1, ssnd(jps_ivx1)%clgrid, 'ij->n', ztmp2 )    ! 2nd component    
+               zitx1(:,:) = ztmp1(:,:)                                                ! overwrite the components    
+               zity1(:,:) = ztmp2(:,:)   
+            ENDIF   
+         ENDIF   
+         !   
+!         ! spherical coordinates to cartesian -> 2 components to 3 components   
+!         IF( TRIM( sn_snd_crtw%clvref ) == 'cartesian' ) THEN   
+!            ztmp1(:,:) = zotx1(:,:)                     ! ocean currents   
+!            ztmp2(:,:) = zoty1(:,:)   
+!            CALL oce2geo ( ztmp1, ztmp2, 'T', zotx1, zoty1, zotz1 )   
+!            !   
+!            IF( ssnd(jps_ivx1)%laction ) THEN           ! ice velocities   
+!               ztmp1(:,:) = zitx1(:,:)   
+!               ztmp1(:,:) = zity1(:,:)   
+!               CALL oce2geo ( ztmp1, ztmp2, 'T', zitx1, zity1, zitz1 )   
+!            ENDIF   
+!         ENDIF   
+         !   
+         IF( ssnd(jps_ocxw)%laction )   CALL cpl_snd( jps_ocxw, isec, RESHAPE ( zotx1, (/jpi,jpj,1/) ), info )   ! ocean x current 1st grid   
+         IF( ssnd(jps_ocyw)%laction )   CALL cpl_snd( jps_ocyw, isec, RESHAPE ( zoty1, (/jpi,jpj,1/) ), info )   ! ocean y current 1st grid   
+         !    
+      ENDIF   
+      !   
+      IF( ssnd(jps_ficet)%laction ) THEN   
+         CALL cpl_snd( jps_ficet, isec, RESHAPE ( fr_i, (/jpi,jpj,1/) ), info )   
+      END IF   
+      !                                                      ! ------------------------- !   
+      !                                                      !   Water levels to waves   !   
+      !                                                      ! ------------------------- !   
+      IF( ssnd(jps_wlev)%laction ) THEN   
+         IF( ln_apr_dyn ) THEN    
+            IF( kt /= nit000 ) THEN    
+               ztmp1(:,:) = sshb(:,:) - 0.5 * ( ssh_ib(:,:) + ssh_ibb(:,:) )    
+            ELSE    
+               ztmp1(:,:) = sshb(:,:)    
+            ENDIF    
+         ELSE    
+            ztmp1(:,:) = sshn(:,:)    
+         ENDIF    
+         CALL cpl_snd( jps_wlev  , isec, RESHAPE ( ztmp1, (/jpi,jpj,1/) ), info )   
+      END IF
       !
       !  Fields sent by OPA to SAS when doing OPA<->SAS coupling
